<xsl:stylesheet id="stylesheet"
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:jiv="http://www.jivesoftware.org"
  xmlns:x="jabber:x:data"
  exclude-result-prefixes="x">
  
  <!-- Output must be 'xml' and not 'text' for the 'STANZA' -->
  <xsl:output omit-xml-declaration="yes" method="xml" indent="yes"/>

  <!-- Include xsl that contains formatDateTime template method -->  
  <xsl:include href="include.xslt"/>
  
  <!-- Reduce to only <presence>s -->
  <xsl:template match="/">
  	<xsl:apply-templates select="//presence[not(@id=preceding::presence/@id)]"/>
  </xsl:template>

   <!-- Parse <presence>s -->
  <xsl:template match="presence[not(@id=preceding::presence/@id)]">
  	<xsl:text>
INSERT INTO "PUBLIC"."OFCONPARTICIPANT"
("CONVERSATIONID", "JOINEDDATE", "LEFTDATE", "BAREJID", "JIDRESOURCE", "NICKNAME")  
VALUES ( 
	</xsl:text>	
	<!-- CONVERSATIONID -->
	<xsl:value-of select="position()"/>
	<xsl:text>,</xsl:text>
	<!-- JOINEDDATE -->
    <xsl:call-template name="formatDateTime">
        <xsl:with-param name="dateTimeString" select="../@timestamp" />
    </xsl:call-template>
	<!-- LEFTDATE -->
	<xsl:text>,NULL</xsl:text>	
	<xsl:text>,'</xsl:text>
	<xsl:choose>
		<xsl:when test="contains(@from, '/')">
			<!-- BAREJID -->
			<xsl:value-of select="substring-before(@from, '/')"/>
			<xsl:text>','</xsl:text>
			<!-- JIDRESOURCE -->
			<xsl:value-of select="substring-after(@from, '/')"/>	
			<xsl:text>'</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="@from"/>
			<xsl:text>',NULL</xsl:text>
		</xsl:otherwise>	
	</xsl:choose>
	<xsl:text>,</xsl:text>	
	<!-- NICKNAME -->
	<xsl:text>NULL);&#xa;</xsl:text>
  </xsl:template>
  
</xsl:stylesheet>
