<xsl:stylesheet id="stylesheet"
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:jiv="http://www.jivesoftware.org"
  xmlns:x="jabber:x:data"
  exclude-result-prefixes="x">
  
  <!-- Output must be 'xml' and not 'text' for the 'STANZA' -->
  <xsl:output omit-xml-declaration="yes" method="xml" indent="yes"/>
  
   <!-- Reduce to only <message>s -->
  <xsl:template match="/">
  	<xsl:apply-templates select="//message[body][not(@id=preceding::message/@id)]"/>
  </xsl:template>

   <!-- Parse <message>s -->
  <xsl:template match="message[not(@id=preceding::message/@id)]">
  	<xsl:text>
INSERT INTO "PUBLIC"."OFCONVERSATION"
("CONVERSATIONID", "ROOM", "ISEXTERNAL", "STARTDATE", "LASTACTIVITY", "MESSAGECOUNT")  
VALUES ( 
	</xsl:text>	
	<!-- CONVERSATIONID -->
	<xsl:value-of select="position()"/>
	<xsl:text>,</xsl:text>
	<!-- ROOM -->
    <xsl:text>NULL</xsl:text>	
	<xsl:text>,</xsl:text>
	<!-- ISEXTERNAL -->
    <xsl:text>0</xsl:text>	
	<xsl:text>,</xsl:text>	
	<!-- STARTDATE -->
    <xsl:text>(SELECT MIN(SENTDATE) FROM "PUBLIC"."OFMESSAGEARCHIVE" a WHERE a.CONVERSATIONID=</xsl:text>
	<xsl:value-of select="position()"/>	
	<xsl:text>,</xsl:text>
	<!-- LASTACTIVITY -->
    <xsl:text>(SELECT MAX(SENTDATE) FROM "PUBLIC"."OFMESSAGEARCHIVE" a WHERE a.CONVERSATIONID=</xsl:text>
	<xsl:value-of select="position()"/>		
	<xsl:text>,</xsl:text>
	<!-- MESSAGECOUNT -->
	<xsl:text>(SELECT COUNT(*) FROM "PUBLIC"."OFMESSAGEARCHIVE" a WHERE a.CONVERSATIONID=</xsl:text>
	<xsl:value-of select="position()"/>
	<xsl:text>));&#xa;</xsl:text>	
  </xsl:template>
    
</xsl:stylesheet>
