<xsl:stylesheet id="stylesheet"
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:jiv="http://www.jivesoftware.org"
  xmlns:x="jabber:x:data"
  exclude-result-prefixes="x">
  
  <!-- Output must be 'xml' and not 'text' for the 'STANZA' -->
  <xsl:output omit-xml-declaration="yes" method="xml" indent="yes"/>
  <!-- Include xsl that contains formatDateTime template method -->  
  <xsl:include href="include.xslt"/>
   
   <!-- Reduce to only <message>s -->
  <xsl:template match="/">
  	<xsl:apply-templates select="//message[body][not(@id=preceding::message/@id)]"/>
  </xsl:template>

   <!-- Parse <message>s -->
   <!-- INSERT INTO "PUBLIC"."OFCONSTREAM" (STREAMID) VALUES(-->
  <xsl:template match="message[not(@id=preceding::message/@id)]">
    <xsl:variable name="apos">'</xsl:variable>
	<xsl:text>
MERGE INTO "PUBLIC"."OFCONSTREAM" a USING (VALUES (
	</xsl:text>  	
	<xsl:text>'</xsl:text>
	<xsl:value-of select="../@streamID"/>
	<xsl:text>'</xsl:text>
	<xsl:text>
)) AS b(x) ON a.STREAMID=b.x WHEN NOT MATCHED THEN INSERT (STREAMID) VALUES (b.x);&#xa; 	
	</xsl:text>  	
	
  	<xsl:text>
INSERT INTO "PUBLIC"."OFMESSAGEARCHIVE"
("MESSAGEID", "CONVERSATIONID", "FROMJID", "FROMJIDRESOURCE", "TOJID", "TOJIDRESOURCE", "SENTDATE", "STANZA", "BODY")  
VALUES ( 
	</xsl:text>
	<!-- MESSAGEID -->	
	<xsl:text>(SELECT COALESCE(MAX(MESSAGEID),0)+1 FROM "PUBLIC"."OFMESSAGEARCHIVE"),</xsl:text>	
	<!-- CONVERSATIONID -->
	<xsl:call-template name="getConversationId">
        <xsl:with-param name="stream_Id" select="../@streamID" />
    </xsl:call-template>		
	<xsl:text>,'</xsl:text>
	
	<xsl:choose>
		<xsl:when test="contains(@from, '/')">
			<!-- FROMJID -->
			<xsl:value-of select="substring-before(@from, '/')"/>
			<xsl:text>','</xsl:text>
			<!-- FROMJIDRESOURCE -->
			<xsl:value-of select="substring-after(@from, '/')"/>	
			<xsl:text>'</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="@from"/>
			<xsl:text>',NULL</xsl:text>
		</xsl:otherwise>	
	</xsl:choose>
	<xsl:text>,'</xsl:text>	
	<xsl:choose>
		<xsl:when test="contains(@to, '/')">
			<!-- TOJID -->
			<xsl:value-of select="substring-before(@to, '/')"/>
			<xsl:text>','</xsl:text>
			<!-- TOJIDRESOURCE -->
			<xsl:value-of select="substring-after(@to, '/')"/>
			<xsl:text>'</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="@to"/>
			<xsl:text>',NULL</xsl:text>
		</xsl:otherwise>	
	</xsl:choose>		
	<xsl:text>,</xsl:text>	
	<!-- SENTDATE -->
    <xsl:call-template name="formatDateTime">
        <xsl:with-param name="dateTimeString" select="../@timestamp" />
    </xsl:call-template>	
	<xsl:text>,'</xsl:text>
	<!-- STANZA -->	
	<xsl:copy-of select="."/>
	<xsl:text>','</xsl:text>
	<!-- BODY -->	
	<xsl:call-template name="replace">
		<xsl:with-param name="text" select="body"/>
    </xsl:call-template>
	<xsl:text>');&#xa;</xsl:text>
  </xsl:template>
</xsl:stylesheet>
