<xsl:stylesheet id="stylesheet"
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <!-- Parses a date of the format: 'Oct 26, 2017 01:27:29:355 PM' and returns seconds (unix time) -->
  <xsl:template name="formatDateTime">
    <xsl:param name="dateTimeString"/>
	<xsl:variable name="apos">'</xsl:variable>
    <xsl:variable name="prefix" select="concat('UNIX_MILLIS(TO_TIMESTAMP(', $apos)"/>
    <xsl:variable name="suffix" select="concat($apos, ', ', $apos, 'MON DD, YYYY HH:MI:SS:FFF', $apos, '))')"/> 
    <xsl:variable name="date" select="substring($dateTimeString, 1, 12)"/>
    <xsl:variable name="hours" select="number(substring($dateTimeString, 14, 2))"/>
    <xsl:variable name="minutes" select="number(substring($dateTimeString, 17, 2))"/>
    <xsl:variable name="seconds" select="number(substring($dateTimeString, 20, 2))"/>
    <xsl:variable name="fractionalseconds" select="number(substring($dateTimeString, 23, 3))"/>
	<xsl:variable name="am" select="substring($dateTimeString, 27, 2)"/>
    <xsl:variable name="modified_hours">
      <xsl:choose>
        <xsl:when test="$am='PM'"><xsl:value-of select="$hours+12"/></xsl:when>
        <xsl:otherwise><xsl:value-of select="$hours" /></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>    
    <xsl:value-of select="concat($prefix, $date, ' ', $modified_hours, ':', $minutes, ':', $seconds, ':', $fractionalseconds, $suffix)"/>
  </xsl:template>
  
  <!-- Replaces ' with '' -->
  <xsl:template name="replace">
    <xsl:param name="text"/>
    <xsl:param name="searchString">'</xsl:param>
    <xsl:param name="replaceString">''</xsl:param>
    <xsl:choose>
        <xsl:when test="contains($text,$searchString)">
            <xsl:value-of select="substring-before($text,$searchString)"/>
            <xsl:value-of select="$replaceString"/>
           <!--  recursive call -->
            <xsl:call-template name="replace">
                <xsl:with-param name="text" select="substring-after($text,$searchString)"/>
                <xsl:with-param name="searchString" select="$searchString"/>
                <xsl:with-param name="replaceString" select="$replaceString"/>
            </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="$text"/>
        </xsl:otherwise>
    </xsl:choose>
  </xsl:template>  

  <!-- Parses a date of the format: 'Oct 26, 2017 01:27:29:355 PM' and returns seconds (unix time) -->
  <xsl:template name="getConversationId">
    <xsl:param name="stream_Id"/>
	<xsl:variable name="apos">'</xsl:variable>
	<xsl:value-of select="concat('(SELECT CONVERSATIONID FROM PUBLIC.OFCONSTREAM WHERE STREAMID=', $apos, $stream_Id, $apos, ')')"/>
  </xsl:template>
  
</xsl:stylesheet>
